name: Build nix packages
on: [push]

jobs:
  build-matrix:
    runs-on: nix
    strategy:
      matrix:
        package: [ "am-kernels", "rv32Cross.am-kernels-nemu", "rv32Cross.am-kernels-npc" ]
    steps:
      - uses: https://github.com/cachix/cachix-action@v14
        with:
          name: ysyx
          authToken: '${{ secrets.CACHIX_SIGNING_KEY }}'
      - uses: actions/checkout@v4
      - name: Cache develop environment
        id: cache-nix-develop
        uses: actions/cache@v4
        with:
          path: |
            /nix/store
            /nix/var/nix/db
          key: nix-develop-${{ hashFiles('flake.*') }}

      - name: Build am-kernels
        run: |
          nix build -L .#${{ matrix.package }}
